﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exemple : L'héritage
# Fichier : unSonSurLaPhoto.fla
# Classe :  Personne.as 
*/



package {
	import gs.TweenLite;
	import gs.easing.*;

	// importer la classe Sprite et Loader
	import flash.display.*;
	// Importer la classe MouseEvent
	import flash.events.*;
	// Pour charger la classe URLRequest
	import flash.net.URLRequest;



	// Définition de la classe Personne
	public class Personne extends Sprite {

		private var prenom:String;
		private var nom:String;
		private var dateNaissance:String;
		private var photo:Loader;
		private var info:InfoClp;
		
		// Définition de la fonction constructeur 
		public function Personne( p:String, n:String, dn:String) {
			setNom(n);
			setPrenom(p);
			setDateNaissance(dn);
			setInfo();
			setPhoto("../../../Photos/"+p+".jpg");
			
		}
		public function setInfo():void {
			info = new InfoClp();
			info.labelOut.text = prenom + "  " + nom + "\n" + dateNaissance;
			addChild(info);
			info.rotationY=90;
			info.alpha = 0;
		}

		public function setPhoto(url:String):void {
			photo= new Loader();
			photo.load(new URLRequest(url));
			photo.contentLoaderInfo.addEventListener(Event.COMPLETE, auComplet);
		}
		
		private function auComplet(evt:Event):void {
			addChildAt(photo,0);
			photo.addEventListener(MouseEvent.MOUSE_OVER, auSurvol);
			photo.addEventListener(MouseEvent.MOUSE_OUT, alExterieur);
			photo.addEventListener(MouseEvent.MOUSE_DOWN, surDown);
		}

		
		private function auSurvol(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			cible.alpha = 0.8;
		}
		private function alExterieur(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			cible.alpha = 1;
		}
		
		private function surDown(e:MouseEvent):void {
			TweenLite.to(info, 1.5, {rotationY:0, alpha:1, ease:Bounce.easeOut, onComplete:surDownInfo});
		}
		
		private function surDownInfo():void {
			info.addEventListener(MouseEvent.MOUSE_DOWN, effaceInfo);
		}
		private function effaceInfo(e:MouseEvent):void {
			TweenLite.to(info, 1.2, {rotationY:90, alpha:0, ease:Strong.easeOut});
		}
		
		
		
		public function setPrenom(p:String):void {
			prenom = p;
		}
		// Modifier le nom
		public function setNom(n:String):void {
			nom = n;
		}
		public function setDateNaissance(dn:String):void {
			dateNaissance = dn;
			
		}
	}
}