/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site  
# Fichier : LesMinis.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	public class LesMinis extends Sprite {
		// Définition des propriétés d'un Mini
		private var listeForme:Array;
		private var listeTitre:Array;
	

		// Définition du constructeur Mini()
		public function LesMinis() {
			listeForme = new Array(MiniSite.listeNoms.length);
			listeTitre = new Array(MiniSite.listeNoms.length);
			for (var i = 0; i < MiniSite.listeNoms.length; i++) {
                // Créer un titre
				listeTitre[i]  = new TitreTexte(40,MiniSite.listeCouleurs[i], 16, "Arial", MiniSite.listeNoms[i]);
				// Créer une forme rectangulaire colorée
				listeForme[i]  =  new Forme(i, MiniSite.largeurMini, MiniSite.hauteurMini,  MiniSite.listeCouleurs[i],  listeTitre[i].contenu, MiniSite.nbElt[i], true);
				// Positionner la forme
				listeForme[i].x = MiniSite.largeurMini*i + MiniSite.finalXMini;
				listeForme[i].y = MiniSite.finalYMini;
				listeForme[i].addEventListener(MouseEvent.MOUSE_OVER, surOver);
				listeForme[i].addEventListener(MouseEvent.MOUSE_OUT, surOut);
				listeForme[i].addEventListener(MouseEvent.MOUSE_UP, clicSurMini);
			}
		}
		// Afficher toutes les mini rubriques sauf celle correspondant au numéro passé en paramètre
		public function afficherLesMinis(num:uint) {
			for (var i = 0; i < listeForme.length; i++) {
				addChild(listeForme[i]);
				listeForme[i].visible = true;
			}
			listeForme[num].visible = false;
		}
		// Rechercher les éléments correspondant à des pages et les supprimer
		private function supprimerLesPages():void {
			for (var i:Number= 0; i < parent.numChildren; i++) {
				if ( parent.getChildAt(i) is Page ) {
					parent.removeChild(parent.getChildAt(i));
				} else {
					if ( parent.getChildAt(i) is Forme ) {
						parent.removeChild(parent.getChildAt(i));
					}
					if ( parent.getChildAt(i) is TitreTexte ) {
						parent.removeChild(parent.getChildAt(i));
					}
				}
			}
		}
		// Quand on clique sur une mini rubrique
		function clicSurMini(e:MouseEvent):void {
			var cible:Forme = e.currentTarget  as Forme;
			// Supprimer le flux vidéo s'il existe
			if (LecteurVideo.unFlux != null) {
				LecteurVideo.unFlux.close();
			}
			// Supprimer les pages
			supprimerLesPages();
			// Créer le titre correspondant à la mini rubrique sélectionnée
			var tmpTitre:TitreTexte = new TitreTexte(90,cible.couleur,75, "Arista", cible.nom);
			// Créer la page correspondant à la mini rubrique sélectionnée
			var tmpPage:Page = new  Page(cible.numero, MiniSite.largeurScene/2, MiniSite.hauteurScene/2,MiniSite.largeurPage/100, MiniSite.hauteurPage/100, cible.couleur, cible.nombreElt,tmpTitre );
			parent.addChild(tmpPage)
			// Afficher la page;
			tmpPage.addEventListener(Event.ENTER_FRAME, afficherPage);
			tmpPage.addEventListener(Event.COMPLETE,sArreter);

		}
		private function afficherPage(e:Event):void {
			var cible:Page = e.currentTarget  as Page;
			cible.agrandirPageEnX();
		}
		private function sArreter(e:Event):void {
			var cible:Page = e.currentTarget  as  Page;
			cible.removeEventListener(Event.ENTER_FRAME, afficherPage);
		}
	// Afficher horizontalement le nom de la rubrique au dessus de la mini rubrique survolée
		function surOver(e:MouseEvent):void {
			var cible:Forme = e.currentTarget  as Forme;
			listeTitre[cible.numero].dessinerHorizontal(cible.x, cible.y-18,false);
			addChild(listeTitre[cible.numero]);
		}
		//Supprimer le titre horizontal
		function surOut(e:MouseEvent):void {
			var cible:Forme = e.currentTarget  as Forme;
			removeChild(listeTitre[cible.numero]);
		}
	}// Fin de la classe LesMinis
}