﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site 
# Fichier : MiniSite.as
*/
package {
	import flash.display.*;
	import flash.events.*;
	import TitreClp;
	public class MiniSite extends Sprite {
		// Définition des constantes utilisées par l'ensemble de l'application
		public static  var largeurScene:uint;
		public static  var hauteurScene:uint;
		public static  const largeurMini:Number=20;
		public static  const hauteurMini:Number=35;
		public static  var largeurRubrique:uint;
		public static  var hauteurRubrique:uint;
		public static  var largeurPage:Number;
		public static  var hauteurPage:Number;
		public static  const finalXPage:uint=0;
		public static  const finalYPage:uint=150;
		public static  var finalXMini:uint=0;
		public static  var finalYMini:uint=150;

		public static  var laVideo:LecteurVideo;
		public static  var listeCouleurs:Array;
		public static  var listeNoms:Array;
		public static  var nbElt:Array;

		public var listeRubriques:Array=new Array(4);
		public var listeTitreRubrique:Array=new Array(4);



		public function MiniSite(nlar:uint,nhau:uint,donneesXML:XML) {

			// Traiter les données XML
			lireDonneesXML(donneesXML);

			// Initialisation des tailles des rubriques et de pages, des positions des minis rubriques
			largeurScene=nlar;
			hauteurScene=nhau;
			largeurRubrique=largeurScene / 4;
			hauteurRubrique=hauteurScene - 150;
			largeurPage=largeurScene;
			hauteurPage=hauteurScene - 150;
			finalYMini=100;
			finalXMini=MiniSite.largeurScene - 100;
			var i:uint;
			// Afficher et traiter le titre
			var titreSite:TitreClp=new TitreClp();
			titreSite.x=20;
			titreSite.y=150;
			addChild(titreSite);
			titreSite.addEventListener(MouseEvent.MOUSE_OVER,surOver);
			titreSite.addEventListener(MouseEvent.MOUSE_OUT,surOut);
			titreSite.addEventListener(MouseEvent.MOUSE_UP,clicSurTitre);
			// Création des rubriques
			for (i=0; i < listeNoms.length; i++) {
				listeTitreRubrique[i]=new TitreTexte(100,listeCouleurs[i],55,"Arista",listeNoms[i]);
				var posX:Number = Math.random()*(largeurScene+ 2*largeurRubrique) - largeurRubrique;
				var posY:Number = Math.random()*(hauteurScene + 2*hauteurRubrique) - hauteurRubrique;
				listeRubriques[i]=new Rubrique(i,posX,posY,listeCouleurs[i],nbElt[i],listeTitreRubrique[i]);
				addChild(listeRubriques[i]);
			}
		}
		// Calculer la longueur d'une branche XML
		private function calculerLongueur(liste:XMLList):uint {
			var compteur:uint=0;
			for each (var elt:XML in liste) {
				compteur++;
			}
			return compteur;
		}
		// Initialiser les tableaux listeCouleurs, listeNoms et nbElt à l'aide des données lues dans le ficheir XML
		private function lireDonneesXML(donneesLues:XML) {
			var listeXML:XMLList=new XMLList;
			listeXML=donneesLues.elements();
			var nbRubriques:uint=calculerLongueur(listeXML);
			listeCouleurs=new Array(nbRubriques);
			listeNoms=new Array(nbRubriques);
			nbElt=new Array(nbRubriques);

			for (var i:int=0; i < nbRubriques; i++) {
				listeCouleurs[i]=donneesLues.rubrique[i].@couleur;
				listeNoms[i]=donneesLues.rubrique[i].@entete;
				nbElt[i]=uint(donneesLues.rubrique[i].@nombre);

			}
		}

		// L'intensité du titre diminue et le curseur prend la forme d'une main
		function surOver(e:MouseEvent):void {
			var cible:Sprite=e.currentTarget  as  Sprite;
			cible.alpha=0.4;
			cible.buttonMode=true;
		}
		// L'opacité du titre  revient à l'état initial
		function surOut(e:MouseEvent):void {
			var cible:Sprite=e.currentTarget  as  Sprite;
			cible.alpha=1;
		}
		// Supprimer une pages quand on clique sur le titre
		private function supprimerLesPages():void {
			Page.lesMinisRubriques = null;
			for (var i:Number=0; i < numChildren; i++) {
				if (getChildAt(i) is Page) {
					removeChild(getChildAt(i));
				}
			}
		}
		// Quand on clique sur le titre la page affichée s'efface, les rubriques réapparaissent
		private function clicSurTitre(e:MouseEvent):void {
			supprimerLesPages();
			if (LecteurVideo.unFlux != null) {
				LecteurVideo.unFlux.close();
			}
			for (var i:uint=0; i < listeNoms.length; i++) {
				removeChild(listeRubriques[i]);
				listeTitreRubrique[i]=new TitreTexte(100,listeCouleurs[i],55,"Arista",listeNoms[i]);
				var posX:Number = Math.random()*(largeurScene+ 2*largeurRubrique) - largeurRubrique;
				var posY:Number = Math.random()*(hauteurScene + 2*hauteurRubrique) - hauteurRubrique;
				listeRubriques[i]= new Rubrique(i,posX,posY,listeCouleurs[i],nbElt[i],listeTitreRubrique[i]);
				addChild(listeRubriques[i]);
			}
		}
	}
}