﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site 
# Fichier : Page.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	public class Page extends Sprite {
		// a. Définition des propriétés d'une Page
		private var forme:Forme;
		private var titre:TitreTexte;
		public static  var lesMinisRubriques:LesMinis;
		private static  var chargeurMmedia:ChargeurPhotoAnimeVideo;
		private static  var chargeurXML:ChargeurInfo;
		// b. Définition du constructeur Page()
		public function Page(nnum:uint, nx:Number, ny:Number, nlar:Number, nhau:Number, ncou:uint,  nelt:uint, ttxt:TitreTexte) {
			titre = ttxt;
			forme = new Forme(nnum, nlar, nhau,  ncou, titre.contenu, nelt, false);
			forme.x = nx;
			forme.y = ny;
			forme.alpha = 0;
			addChild(forme);
			if (lesMinisRubriques == null) {
				lesMinisRubriques = new LesMinis();
				addChild(lesMinisRubriques);
			}
			// pour effacer le  contenu de la page Infos
			if (chargeurXML!= null) {
				chargeurXML.visible = false;
				chargeurXML = null;
			}
			// pour effacer le  contenu des pages Photos, Amimes et Video
			if (chargeurMmedia!= null) {
				chargeurMmedia.visible = false;
				chargeurMmedia = null;
			}
			switch (titre.contenu) {
				case "Photos" :
				case "Animes" :
				case "Videos" :
				    // Charger les pages Photos, Animes ou Videos
					chargeurMmedia= new ChargeurPhotoAnimeVideo(titre.contenu, nelt);
					break;
				case "Infos" :
				 	// Charger la page Infos
					chargeurXML= new  ChargeurInfo(titre.contenu) ;
					break;
			}
		}
		function agrandirPageEnX():void {
			var ecartX:Number;
			var positionCouranteX:Number;
			var deplacementX:Number;
			positionCouranteX = forme. x;
			ecartX = MiniSite.finalXPage - positionCouranteX;
			deplacementX= ecartX / 6;
			forme.x= positionCouranteX + deplacementX;
			forme.width+=MiniSite.largeurScene/25;
			forme.alpha+=0.05;
			if (Math.abs(deplacementX)  < 0.4) {
				forme.removeEventListener(Event.ENTER_FRAME, agrandirPageEnX);
				forme.addEventListener(Event.ENTER_FRAME, agrandirPageEnY);
				dispatchEvent(new Event(Event.COMPLETE));
				forme.alpha = 1;
				forme.width=MiniSite.largeurPage;
			}
		}


		function agrandirPageEnY(e:Event):void {
			var cible:Forme = e.currentTarget  as Forme;
			var ecartY:Number;
			var positionCouranteY:Number;
			var deplacementY:Number;
			cible.height+=MiniSite.hauteurScene/24;
			positionCouranteY = cible. y;
			ecartY = MiniSite.finalYPage - positionCouranteY;
			deplacementY= ecartY / 6;
			cible.y= positionCouranteY + deplacementY;

			if (Math.abs(deplacementY)  < 0.4) {
				cible.removeEventListener(Event.ENTER_FRAME, agrandirPageEnY);
				cible.height = MiniSite.hauteurPage;
				cible.x =MiniSite.finalXPage;
				cible.y =MiniSite.finalYPage;
				cible.alpha = 1;
				titre.dessinerVertical(MiniSite.largeurPage - 100, MiniSite.finalYPage+10);
				lesMinisRubriques.afficherLesMinis(cible.numero);
				addChild(titre);
				if (chargeurMmedia!= null) {
					// Afficher les photos, vidéos ou animmes
					addChild(chargeurMmedia);

				} else if (chargeurXML!= null) {
					// Afficher les infos
					addChild(chargeurXML);
				}
			}
		}

	}// Fin de la classe Page
}